#include "comp.h"

int16_t Comp1_init(void);
int16_t Comp2_init(void);

int16_t slopeDecStep=0x0;

int16_t Comp_init(void)
{
	int16_t retval = 0;
	retval = Comp1_init();
	retval = Comp2_init();
	return retval;
}

int16_t Comp1_init(void)
{
	// how to trip EPWM1A

	EALLOW;
	GpioCtrlRegs.AIOMUX1.bit.AIO2 = 0x2; // comp1a
	EDIS;
	
	EALLOW;
	Comp1Regs.COMPCTL.bit.COMPDACEN = 0x1; // Internal Dac is Power On
	Comp1Regs.COMPCTL.bit.SYNCSEL = 0x1; // Synchronous of output
	Comp1Regs.COMPCTL.bit.QUALSEL = 0x2; // 3 clocks
	Comp1Regs.COMPCTL.bit.CMPINV = 0x0; // No inverter
	Comp1Regs.COMPCTL.bit.COMPSOURCE = 0x0; // Input connected to internal DAC

//	Comp1Regs.COMPSTS
	Comp1Regs.DACCTL.bit.FREE_SOFT = 0x2; // run free
	Comp1Regs.DACCTL.bit.RAMPSOURCE = 0x0; // PWMSYNC1 is the source sync
	Comp1Regs.DACCTL.bit.DACSOURCE = 0x1; // DAC controlled by RAMP
	Comp1Regs.DACVAL.bit.DACVAL = 0x0; // ??
//	Comp1Regs.RAMPMAXREF_ACTIVE
	Comp1Regs.RAMPMAXREF_SHDW = 0x0; //
//	Comp1Regs.RAMPDECVAL_ACTIVE
	Comp1Regs.RAMPDECVAL_SHDW = slopeDecStep; //
//	Comp1Regs.RAMPSTS
	EDIS;

	return 0;
}

int16_t Comp2_init(void)
{
	EALLOW;
	GpioCtrlRegs.AIOMUX1.bit.AIO4 = 0x2; // comp2a
	EDIS;

	EALLOW;
	Comp2Regs.COMPCTL.bit.COMPDACEN = 0x1; // Internal Dac is Power On
	Comp2Regs.COMPCTL.bit.SYNCSEL = 0x1; // Synchronous of output
	Comp2Regs.COMPCTL.bit.QUALSEL = 0x2; // 3 clocks
	Comp2Regs.COMPCTL.bit.CMPINV = 0x0; // No inverter
	Comp2Regs.COMPCTL.bit.COMPSOURCE = 0x0; // Input connected to internal DAC

//	Comp2Regs.COMPSTS
	Comp2Regs.DACCTL.bit.FREE_SOFT = 0x2; // run free
	Comp2Regs.DACCTL.bit.RAMPSOURCE = 0x1; // PWMSYNC2 is the source sync
	Comp2Regs.DACCTL.bit.DACSOURCE = 0x1; // DAC controlled by RAMP
	Comp2Regs.DACVAL.bit.DACVAL = 0x0; // ??
//	Comp2Regs.RAMPMAXREF_ACTIVE
	Comp2Regs.RAMPMAXREF_SHDW = 0x0; //
//	Comp2Regs.RAMPDECVAL_ACTIVE
	Comp2Regs.RAMPDECVAL_SHDW = slopeDecStep; //
//	Comp2Regs.RAMPSTS
	EDIS;

	return 0;
}

